{{ NordicPlusPlusDemo110416f

  This demo uses two nRF24L01+ modules to
  communicate.  It can also have two
  nRF2401A modules communicate with eachother.
  I can't get a nRF24L01+ to communicate with
  a nRF2401A.
  Change the value of "_CurrentConfig" (last constant)
  to change which type of modules this object
  will use.
  
  This code is mainly base on C code posted
  by Leon in the Propeller Forum.
  
  ---- Revision Notes -------
  110404a change to use older Nordic as aux.
  4a didn't work.
  7a move code from Nordic object to this
  top object to make file matainence easier.
  7d fix problem with reading packet.  7d works.
  8a change transmitString method (and others)
  to point to string.  8b change packet length
  to 32 bytes.  8b works.  c make payload size
  a variable.  c works.  d try enhanced ShockBurst.
  9a take out timing delays, they aren't needed.
  9b use SPI_Asm.  b doesn't work.  c doesn't
  work.  d works using old SPI method.  e read
  SPI with new method.  e works.  f use Asm to
  write SPI commands as well.  f works.
  g remove delay in PASM code of SPI object.
  g works.  h move Nordic methods to separate
  object.  i works.  j try to make rx and tx
  changeable.  j doesn't work.  Abandon j.
  10a try smaller changes.  a switch rx and
  tx mode values. a works.  b works.  c works.
  d works.  e uses two way com and works.
  f added minimum needed to reset rx to transmitString
  method.
  11d works.  12d doesn't really work.
  13a didn't work either.  It would alternate
  between all "!!!!!..." and "gggg...".
  13b moved parameters to DAT section of this
  object.  b works (using same parameters as
  previous versions).  c try changing some
  parameters.  Enhanced ShockBurst seems to work
  but I'm not sure yet.  I need to read
  retransmitted packets.
  14b try to communicate with older Nordic module.
  b, c and d don't work.  e use a case statement
  to start new or old Nordic modules.  e doesn't
  work with two new modules.  h works. i use
  25 byte packet and other setting to use with
  older modules.  i works.  j try to use two
  old modules.  Device 0 receives okay but device
  1 isn't receiving.  l works with two old modules.
  m with one old and one new.  m doesn't work.
  n get ready to archive an post to forum.  Make
  messages more helpful.  15a test a couple more
  adress combinations and clean up child object.
  15a and 16a don't work.  Did I change too many
  things when I cleaned up the program?  b works.
  The problem was in a change I made to the SPI
  driver.  c try some different address combinations.
  c this combination lets device 0 receive but not
  device 1.  d try other combinations.  d leave it
  in combination that does work.  e try two old
  modules.  e using the same address for both
  modules works.  I didn't think it would.
  f try one new and one old.  f doesn't work
  with one new module and one old module.  Time
  to ask for help.
  
}}
'' Adapted from:
''( I don't think think there is much left of
''the original code.)
''****************************************
''*  nFR24L01 Demo                       *
''*  Authors: Nikita Kareev              *
''   The above demo didn't work
''   Much of this code is based on C code by Leon
 
CON
  _clkmode = xtal1 + pll16x                           
  _xinfreq = 5_000_000
    
CON

  'Pins to Nordic0 nRF24L01+
  SPI_CE = 11
  SPI_CSN = 12     
  SPI_SCK = 13 
  SPI_MOSI = 14
  SPI_MISO = 15
  SPI_IRQ = 16

CON

  _RxLed0 = 0   ' set high to turn LED on
  _TxLed0 = 1   ' set high to turn LED on
  _RxLed1 = 2   ' set high to turn LED on
  _TxLed1 = 3   ' set high to turn LED on

  'Pins to Nordic1 nRF24L01+   
  SPI_CE1 = 5
  SPI_CSN1 = 6     
  SPI_SCK1 = 7 
  SPI_MOSI1 = 8
  SPI_MISO1 = 9
  SPI_IRQ1 = 10

  'Pins to Nordic2 nRF2401A
  CE = 11
  CS = 12     
  DR = 13 
  SCK = 14
  DATA = 15

  'Pins to Nordic3 nRF2401A 
  CE1 = 5
  CS1 = 6     
  DR1 = 7 
  SCK1 = 8
  DATA1 = 9
  

  ' Device enumeration (future use)
  '#1, _NordicA, _NordicBaseStation, _NordicInputDevice, _NordicD

  ' modes
  #0, _Nordic0RxOnlyMode, _Nordic0TxMode

  _LargestPayloadSize = 32
  _DefaultPayloadSize = _LargestPayloadSize
  
  ' Module configuration enumeration
  #0, _TwoNewModules, _TwoOldModules, _OneNewAndOneOld

CON  _CurrentConfig = _TwoNewModules  ' Change this to use a different combination of modules
 
VAR

  long nordicStack[100], debugLock 

  byte SpiIrq[2]
  byte payloadSize
  byte globalPayload0[_LargestPayloadSize + 1] ' Add 1 so a terminating zero may be added if desired.
  byte globalPayload1[_LargestPayloadSize + 1] 
                                               
  byte globalMode
  'byte lostPackets[2], retxPackets[2] ' Not used yet
  byte ModuleConfiguration

OBJ   

  Debug : "FullDuplexSerialPlus"   
  Nordic0 : "dwd_nRF24L01Beta110416a"                 'Nordic nRF24L01
  Nordic1 : "dwd_nRF24L01Beta110416a"                 'Nordic nRF24L01
  Nordic2 : "Nordic100923a"
  Nordic3 : "Nordic100923a"
  
PUB Demo | localIndex 


  Debug.start(31, 30, 0, 57600)
  debugLock := locknew
  waitcnt(clkfreq * 2 + cnt)
  Debug.str(String("Start of Nordic Demo", 13))
  
  SpiIrq[0] := SPI_IRQ          ' These are only used with new modules
  SpiIrq[1] := SPI_IRQ1

  dira[_RxLed0]~~
  dira[_TxLed0]~~
  
  
  ModuleConfiguration := _CurrentConfig
  repeat until not lockset(debugLock) ' treating it like a driver init lock 
                                      ' The new cog will clear the lock to make sure only
                                      ' one SPI driver is started at a time.
  case ModuleConfiguration
    _TwoNewModules:
      Debug.str(String("Two new modules are being used.", 13))
      result := cognew(secondNordicNew, @nordicStack)
      NordicNew(result) 
    _TwoOldModules:
      Debug.str(String("Two old modules are being used.", 13))
      result := cognew(secondNordicOld, @nordicStack)
      NordicOld(result) 
    _OneNewAndOneOld:
      Debug.str(String("One new module and one old module are being used.", 13))
      result := cognew(secondNordicOld, @nordicStack)
      NordicNew(result)

PUB NordicNew(secondCog) | localIndex

  'Initialize Nordic nRF24L01
  payloadSize := byte[@configNew + 7] '_DefaultPayloadSize
  waitcnt(clkfreq / 4 + cnt)
  repeat until not lockset(debugLock) ' treating it like a driver init lock
                                      ' wait for driver in other cog to finish loading
  Nordic0.Start(SPI_SCK, SPI_MISO, SPI_MOSI, SPI_CSN, SPI_CE, @configNew, @nordicStatus, @rxAddress0)
                           
   
  Debug.str(String(13, "Nordic 0 Started", 13))
  Debug.str(String("rx address ="))
  repeat localIndex from 0 to 4
    Debug.str(String(" $"))
    Debug.hex(byte[@rxAddress0 + localIndex], 2)
  Debug.str(String(13, "tx address ="))
  repeat localIndex from 5 to 9
    Debug.str(String(" $"))
    Debug.hex(byte[@rxAddress0 + localIndex], 2)
  
  lockclr(debugLock) 
  'waitcnt(clkfreq + cnt)
  'Set IRQ pin states 
  dira[SpiIrq[0]]~

  repeat until not lockset(debugLock) 
  Debug.str(String(13, "Second Nordic Module monitored on cog #"))
  'Debug.dec(result)
  Debug.dec(secondCog)
  Debug.tx(13)
  lockclr(debugLock) 
  'waitcnt(clkfreq /2 + cnt)
  repeat until not lockset(debugLock)
  Debug.str(String("Receiver (new module) configured. Waiting for packets...", 13))
  lockclr(debugLock) 
  repeat
    if globalMode == _Nordic0TxMode
      outa[_TxLed0]~~ 
      Nordic0.TransmitString(@test3)
      outa[_TxLed0]~
    'waitcnt(clkfreq / 2 + cnt)
    
    if ina[SpiIrq[0]]  == 0 'Wait for incoming data
      'We have some data
      repeat until not lockset(debugLock)
      Debug.str(String("Status 0 = %"))
      localIndex := Nordic0.Status
      Debug.bin(localIndex, 8)
      Debug.tx(13)
      lockclr(debugLock) 
      outa[_RxLed0]~~
      Nordic0.ReadPayload(@globalPayload0)
      repeat until not lockset(debugLock)
      Debug.str(String("Data received 0: "))
      repeat localIndex from 0 to payloadSize - 1
        if globalPayload0[localIndex] => 32 and globalPayload0[localIndex] =< 127
          Debug.tx(globalPayload0[localIndex])
        else
          Debug.hex(globalPayload0[localIndex], 2)
      Debug.tx(13)
      lockclr(debugLock) 
      outa[_RxLed0]~
      
PUB NordicOld(secondCog) | localIndex

  'Initialize Nordic nRF24L01
  payloadSize := byte[@configNew + 7]
  payloadSize <#= 25 
  waitcnt(clkfreq / 4 + cnt)
  
  repeat until not lockset(debugLock)  ' wait for driver in other cog to finish loading
  result := Nordic2.Init(CS, CE, SCK, DR, DATA)    
  Nordic2.configure(@nordicConfig2)
  'Nordic2.configure(@nordicConfig3)
  Nordic2.setmode(1)

  Debug.str(String(13, "Nordic 0 Started (old module)", 13))
  Debug.str(String("rx address ="))
  repeat localIndex from 7 to 11
    Debug.str(String(" $"))
    Debug.hex(byte[@nordicConfig2 + localIndex], 2)
  Debug.str(String(13, "tx address ="))
  repeat localIndex from 0 to 4
    Debug.str(String(" $"))
    Debug.hex(byte[@nordicTx2 + localIndex], 2)
  lockclr(debugLock) 
  waitcnt(clkfreq /4 + cnt)
  
  
  repeat until not lockset(debugLock) 
  Debug.str(String(13, "Second Nordic Module monitored on cog #"))
  Debug.dec(secondCog)
  Debug.tx(13)
  lockclr(debugLock) 
  waitcnt(clkfreq / 8 + cnt)
  repeat until not lockset(debugLock)
  Debug.str(String("Receiver (old module) configured. Waiting for packets...", 13))
  lockclr(debugLock) 
  repeat
    if globalMode == _Nordic0TxMode
      outa[_TxLed0]~~ 
      Nordic2.xmit(@nordicTx2)
      'Nordic2.xmit(@nordicTx3)
      outa[_TxLed0]~
    'waitcnt(clkfreq / 2 + cnt)
    
    if ina[DR] == 1 
      'We have some data
      
      outa[_RxLed0]~~
      Nordic2.recv(@globalPayload0) 
      repeat until not lockset(debugLock)
      Debug.str(String("Data received 0: "))
      repeat localIndex from 0 to payloadSize - 1
        if globalPayload0[localIndex] => 32 and globalPayload0[localIndex] =< 127
          Debug.tx(globalPayload0[localIndex])
        else
          Debug.hex(globalPayload0[localIndex], 2)
      Debug.tx(13)
      lockclr(debugLock) 
      outa[_RxLed0]~
      
PUB SecondNordicNew | localIndex, loopCount

  
  'Initialize Nordic nRF24L01
  result := Nordic1.Start(SPI_SCK1, SPI_MISO1, SPI_MOSI1, SPI_CSN1, SPI_CE1, @configNew, @nordicStatus, @rxAddress1)
  
  Debug.str(String("Second SPI started on cog # "))
  Debug.dec(result)
  Debug.tx(13)
  
  Debug.str(String("Nordic 1 Started (new module)", 13))
  Debug.str(String("rx address ="))
  repeat localIndex from 0 to 4
    Debug.str(String(" $"))
    Debug.hex(byte[@rxAddress1 + localIndex], 2)
  Debug.str(String(13, "tx address ="))
  repeat localIndex from 5 to 9
    Debug.str(String(" $"))
    Debug.hex(byte[@rxAddress1 + localIndex], 2)
  Debug.tx(13)
  lockclr(debugLock)
  
  waitcnt(clkfreq / 4 + cnt)

  'Set IRQ pin state 
  dira[SpiIrq[1]]~

  dira[_RxLed1]~~
  dira[_TxLed1]~~

  loopCount := 0
  repeat
    waitcnt((clkfreq / 2) * 3 + cnt)
    outa[_TxLed1]~~
   
    if loopCount // 2 == 0
      Nordic1.TransmitString(@test1)
    else
      Nordic1.TransmitString(@test2)
    {ObserveTx(1) 
    repeat until not lockset(debugLock)
    Debug.str(String(13, "retxPackets[1] = "))
    Debug.dec(retxPackets[1])
    Debug.str(String(", lostPackets[1] = "))
    Debug.dec(lostPackets[1])
    Debug.tx(13)
    lockclr(debugLock)}   
    waitcnt(clkfreq / 2 + cnt)
    outa[_TxLed1]~ 
    globalMode := _Nordic0TxMode 
    waitcnt(clkfreq / 4 + cnt)
    globalMode := _Nordic0RxOnlyMode
    
    loopCount++
    if ina[SpiIrq[1]]  == 0 'Wait for incoming data
      'We have some data
      Nordic1.ReadPayload(@globalPayload1)
      repeat until not lockset(debugLock)
      Debug.str(String("Data received 1 : "))
    
      repeat localIndex from 0 to payloadSize - 1
        if globalPayload1[localIndex] => 32 and globalPayload1[localIndex] =< 127
          Debug.tx(globalPayload1[localIndex])
        else
          Debug.hex(globalPayload1[localIndex], 2)
      Debug.tx(13)
      lockclr(debugLock)
      
PUB SecondNordicOld | localIndex, loopCount

  
  result := Nordic3.Init( CS1, CE1, SCK1, DR1, DATA1 )    'Initialize TRF24G
  Nordic3.configure(@nordicConfig3)
  'Nordic3.configure(@nordicConfig2)
  Nordic3.setmode(1)

  Debug.str(String("Second Nordic Device Started (old module)"))
  Debug.tx(13)
  Debug.str(String("Nordic 1 Started (old module)", 13))
  Debug.str(String("rx address ="))
  repeat localIndex from 7 to 11
    Debug.str(String(" $"))
    Debug.hex(byte[@nordicConfig3 + localIndex], 2)
  Debug.str(String(13, "tx address ="))
  repeat localIndex from 0 to 4
    Debug.str(String(" $"))
    Debug.hex(byte[@nordicTx3 + localIndex], 2)
  lockclr(debugLock) ' allow other drivers to start 
  waitcnt(clkfreq / 4 + cnt)
  

  dira[_RxLed1]~~
  dira[_TxLed1]~~

  loopCount := 0
  repeat
    waitcnt((clkfreq / 2) * 3 + cnt)
    outa[_TxLed1]~~
    Nordic3.xmit(@nordicTx3)
    'waitcnt(clkfreq / 4 + cnt) 
    'Nordic3.xmit(@nordicTx2)
    waitcnt(clkfreq / 2 + cnt)
    outa[_TxLed1]~ 
    globalMode := _Nordic0TxMode 
    waitcnt(clkfreq / 4 + cnt)
    globalMode := _Nordic0RxOnlyMode
    
    loopCount++
    if ina[DR1] == 1 'Check for incoming data
      'We have some data
      outa[_RxLed1]~~
      Nordic3.recv(@globalPayload1)
      repeat until not lockset(debugLock)
      Debug.str(String("Data received 1 : "))
     
      repeat localIndex from 0 to payloadSize - 1
        if globalPayload1[localIndex] => 32 and globalPayload1[localIndex] =< 127
          Debug.tx(globalPayload1[localIndex])
        else
          Debug.hex(globalPayload1[localIndex], 2)
      Debug.tx(13)
      lockclr(debugLock)
      outa[_RxLed1]~
      
{PUB ObserveTx(device) ' For future use

  'result := Nordic[device].SpiReadPub(Nordic#OBSERVE_TX, @lostPackets + device, 1)
  result := Nordic0[device].SpiReadPub(Nordic0#OBSERVE_TX, @lostPackets + device, 1)
  retxPackets[device] :=  lostPackets[device] << 4
  retxPackets[device] >>= 4     ' how do you andn in Spin?
  lostPackets[device] >>= 4 
}
DAT
                         '1         2         3
               '01234567890123456789012345678901
test1     byte "test1 25 byte payload  25 28  32", 0

                         '1         2         3
               '01234567890123456789012345678901
test2     byte "test2 25 byte payload  25 28  32", 0

               '01234567890123456789012345678901
test3     byte "test3 25 byte payload  25 28  32", 0


''------------------ Cofig settings for new nRF24L01+ modules ----------------------------------------
'' ----------------- Keep below together and in order ------------------------------------------------
configNew     byte %00111111 '%00111011  Register $00
              ' use %00111111($3F)(2 bytes CRC) or %00111011($3B)(1 byte CRC)
              ' when communicating with older nRF2401A modules
              ' make sure this matches nRF2401A setting
              ' %00001111($0F) future with more irq options
              ' 7 only zero allowed, 6 Mask irq by RX_DR (1 = no irq), 5 Mask TX_DS, 4 Mask MAX_RT,
              ' 3 Enable CRC, 2 CRC size (1 = 2 bytes), 1 1 = power up, 0 1 = PRX 0 = PTX
              ' RX_DR Receive Data Ready
              ' TX_DS Transmit Data Sent
              ' MAX_RT Maximum Retries
              byte $00 '$03 ' Register $01 Auto Acknowledge
              ' use $00 when communicating with older nRF2401A modules
              ' %00111111 future
              ' 7:6 only %00, enable pipe 5 through 0
              byte %00000011 ' Register $02
              ' 7:6 only zero allowed, 5:0 enable rx addresses pipe 5:0
              byte $03 ' Register $03 SETUP_AW setup Address Widths 
              ' 7:2 only %000000, 1:0 %01 = 3 %11 = 5
              byte $00 ' Register $04 SETUP_RETR Setup Auto Retransmission
              ' use $00 when communicating with older nRF2401A modules     
              ' %00101111 = 750us delay to retx, tx 15 tries
              ' %01001111 = 1250us delay to retx, tx 15 tries
              ' 7:4 ARD delay 1111 = 4000us, 3:0 retry count 0 - 15 (1111)
              byte $02 ' Register $05 RF_CH RF Channel
              ' 7 leave 0, 6:0 frequency channel
              ' F = (2400 + RF_CH)MHz (both nRF24L01+ and nRF2401A modules)
              byte $06 ' Register $06 RF_SETUP RF Setup
              ' don't use 2Mbps when communicating with older nRF2401A modules
              ' $06 = 1Mbps and full power
              ' 7:6 %00 only, 5 RF_DR_LOW 1 = 250kbps use 0 for higher speeds, 4 leave %0
              ' 3 1 = 2Mbps 0 = 1Mbps, 2:1 RF_POWER %11 = 0dBm (highest power), 0 don't care
              ' Register $07 STATUS Status Register used below.
              ' Register $08 OBSERVE_TX 7:4 lost packet count (read only),
              ' 3:0 retransmitted packets count (read only).  I plan to use this
              ' register's infomation in the future.
              ' Register $09 RPD 7:1 reserved (read only), 0 Received Power Detector (read only)
              ' Register $0A RX_ADDR_P0 39:0 Receive address pipe 0, 5 bytes maximum LSByte written first
              ' used below rxAddress0 and rxAddress1
              ' Register $0B RX_ADDR_P1 39:0 Receive address pipe 1
              ' Register $0C RX_ADDR_P2 7:0 Receive address pipe 2
              ' Register $0D RX_ADDR_P3 7:0 Receive address pipe 3
              ' Register $0E RX_ADDR_P4 7:0 Receive address pipe 4
              ' Register $0F RX_ADDR_P5 7:0 Receive address pipe 5
              ' Register $10 TX_ADDR 39:0 Transmit address
'configNew[7]
rxPayload     byte 25 '32   ' Register $11 RX_PW_P0
              ' This will need to be reduced to 25 (assuming 2 bytes CRC and 5 bytes address)
              ' to work with older nRF2401 modules.
              ' Newer nRF24L01+ modules can have payloads as large as 32 bytes.
              ' 7:6 only zero allowed, 5:0 Number of bytes in RX payload in data pipe 0
              ' (1 to 32)(0 = pipe not used)
              ' Register $12 RX_PW_P1 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 1
              ' (1 to 32)(0 = pipe not used)
              ' Register $13 RX_PW_P2 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 2
              ' Register $14 RX_PW_P3 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 3
              ' Register $15 RX_PW_P4 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 4
              ' Register $16 RX_PW_P5 7:6 only zero allowed,
              ' 5:0 Number of bytes in RX payload in data pipe 5
              ' Register $17 FIFO_STATUS 7 only zero allowed, 6 TX_REUSE (read only), 
              ' 5 TX_FULL %1 = full (read only), 4 TX_EMPTY %1 = empty (read only),
              ' 3:2 only zero allowed, 1 RX_FULL %1 = full (read only),
              ' 0 RX_EMPTY %1 = empty (read only)
              ' Register $1C DYNPD Enable dynamic payload length, 7:6 only zero allowed,
              ' 5 DPL_P5 Enable dynamic payload length data pipe 5 (Requires EN_DPL and ENAA_5)
              ' 4 DPL_P4 Enable dynamic payload length data pipe 4 (Requires EN_DPL and ENAA_4)
              ' 3 DPL_P3 Enable dynamic payload length data pipe 3 (Requires EN_DPL and ENAA_3)
              ' 2 DPL_P2 Enable dynamic payload length data pipe 2 (Requires EN_DPL and ENAA_2)
              ' 1 DPL_P1 Enable dynamic payload length data pipe 1 (Requires EN_DPL and ENAA_1)
              ' 0 DPL_P0 Enable dynamic payload length data pipe 0 (Requires EN_DPL and ENAA_0)
              ' Register $1D FEATURE Feature Register 7:3 only zero allowed,
              ' 2 EN_DPL Enables Dynamic Payload Length, 1 EN_ACK_PAY Enables Payload with ACK,
              ' 0 EN_DYN_ACK Enables the W_TX_PAYLOAD_NOACK command
              
'' ----------------- Keep above together and in order ------------------------------------------------             
nordicStatus  byte %01000000 ' $40   %01110000   '$70
              ' only zero allowed, Data Ready RX, TX ACK received, MAX_RT failed,
              ' 3:1 Data pipe with payload %111 if empty (read only), 0 1= TX FIFO full (read only)
'' ----------------- Keep below together and in order ------------------------------------------------             

rxAddress0    byte $E7[5] ' Register $0A Receive address data pipe 0, LSByte first
'rxAddress0    byte $CD, $E7, $E7, $E7, $CD ' Register $0A Receive address data pipe 0, LSByte first

txAddress0    byte $E7[5] ' Register $10 Transmit address data pipe 0, LSByte first
'txAddress0    byte $CD, $E7, $E7, $E7, $CD ' Register $10 Transmit address data pipe 0, LSByte first
'txAddress0    byte $C2, $C2, $C2, $C2, $C2 ' Register $10 Transmit address data pipe 0, LSByte first
'' ----------------- Keep above together and in order ------------------------------------------------             

'' ----------------- Keep below together and in order ------------------------------------------------             

rxAddress1    byte $E7[5] ' Register $0A Receive address data pipe 0, LSByte first
'rxAddress1    byte $CD, $E7, $E7, $E7, $CD ' Register $0A Receive address data pipe 0, LSByte first

txAddress1    byte $E7[5] '  Register $10 Transmit address data pipe 0, LSByte first
'txAddress1    byte $CD, $E7, $E7, $E7, $CD '  Register $10 Transmit address data pipe 0, LSByte first
'txAddress1    byte $C2, $C2, $C2, $C2, $C2 '  Register $10 Transmit address data pipe 0, LSByte first
'' ----------------- Keep above together and in order ------------------------------------------------             



''------------------ Cofig settings for old nRF2401A modules ----------------------------------------
'' ----------------- Keep below together and in order ------------------------------------------------

                                                      '1         2         3
                                            '01234567890123456789012345678901
'nordicTx2     byte $CD, $E7, $E7, $E7, $CD, "tx2 to address$CDE7E7E7CD", 13, 0[14]   
nordicTx2     byte $E7, $E7, $E7, $E7, $E7, "tx2 to address$E7E7E7E7E7", 13, 0[14]   
               
nordicConfig2 byte $C8  ' Data2 width (bits) excluding addr & crc (25 bytes) 
              byte $C8  ' Data1 width (bits) excluding addr & crc (25 bytes)
              byte $E7, $E7, $E7, $E7, $E7 ' Channel #2
              byte $E7, $E7, $E7, $E7, $E7  ' Channel #1 
              byte $A3  ' $A3 = %10100011
              ' 7-2:address width(40), 1:CRC Mode(16), 0:CRC enable(on)
              byte $6F  ' $6F = %01101111
              ' 7:Dual Ch mode(off), 6:ShockBurst mode(on), 5:1m/250k bps(1mbps), 4-2:xtal sel(16Mhz), 1-0:rf Power(hi)
              byte $05  ' $05 = %00000101
              ' 7-1:RF channel(2), 0:RX enable(on=Rx mode)
                                            '0123456789012345678901234
nordicTx3     byte $E7, $E7, $E7, $E7, $E7, "tx3 to address$E7E7E7E7E7", 13, 0[14]   
               
nordicConfig3 byte $C8  ' Data2 width (bits) excluding addr & crc (25 bytes) 
              byte $C8  ' Data1 width (bits) excluding addr & crc (25 bytes)
              byte $CD, $E7, $E7, $E7, $CD  ' Channel #2
              'byte $CD, $E7, $E7, $E7, $CD  ' Channel #1      
              byte $E7, $E7, $E7, $E7, $E7  ' Channel #1      
              'byte $CD, $E7, $E7, $E7, $CD  ' Channel #1      
              byte $A3  ' $A3 = %10100011
              ' 7-2:address width(40), 1:CRC Mode(16), 0:CRC enable(on)
              byte $6F  ' $6F = %01101111
              ' 7:Dual Ch mode(off), 6:ShockBurst mode(on), 5:1m/250k bps(1mbps), 4-2:xtal sel(16Mhz), 1-0:rf Power(hi)
              byte $05  ' $05 = %00000101
              ' 7-1:RF channel(2), 0:RX enable(on=Rx mode)
             