{{ dwd_nRF24L01Beta110415a
  Based on nFR24L01 by Nikita Kareev
  Not much of the original object is left.
  I mostly relied on C code posted by Leon Heller
  on the Propeller Forum.
  Version: Beta01
  By: Duane Degn
  April 15, 2011
  I'm using a modified version of SPI_Asm.
  I removed the delays in the original
  object since these modules can use a
  10MHz SPI clock and require only a 2ns
  delay on the clock after the data pin
  is set.
  Abandon Alpha02.  Alpha03a try making smaller
  changes.  a and b work.  c configure method
  is no longer mode dependent.
  110412d try to add enhancedShockburst.
  d and e don't work but they do ouput something.
  13a revert to older code and start making
  smaller changes.  13a didn't work because
  I hadn't removed changes from TransmitString
  method.  13b works because it's the same
  as 12c except for commented out code.
  13c try to use start up parameters from
  parent memory.  c works.  d add method to
  read retransmitted packets.  15a change
  Alpha in name to Beta, clean up code.
  
}}
''****************************************
''*  nFR24L01                            *
''*  Authors: Nikita Kareev              *
''*  See end of file for terms of use.   *
''****************************************
''
'' Nordic nRF24L01 driver
''
'' http://www.sparkfun.com/commerce/product_info.php?products_id=691
''
'' Updated... 6 SEP 2009
''
'' Rev 0.1 
CON
  ' DWD These constants where in the original object.
  ' DWD Not many are used.

  
  'nRF24L01 constants:
  
  'Commands
  R_REGISTER = %0000_0000 '+ reg
  W_REGISTER = %0010_0000 '+ reg  $20
  R_RX_PAYLOAD = %0110_0001     ' $61
  W_TX_PAYLOAD = %1010_0000     ' $A0
  FLUSH_TX = %1110_0001         ' $E1
  FLUSH_RX = %1110_0010         ' $E2
  REUSE_TX_PL = %1110_0011      ' $E3
  R_RX_PL_WID = %0110_0000      ' $30
  W_ACK_PAYLOAD = %1010_1000 '+ pipe  ' $A8
  W_TX_PAYLOAD_NOACK = %1011_0000 ' $B0
  NOOP = %1111_1111             ' $FF
                                
  'Registers
  CONFIG = $00   '%0000_1000 / $08
  EN_AA = $01  '%0011_1111  / $3F
  EN_RXADDR = $02  '%0000_0011
  SETUP_AW = $03   '%0000_0011
  SETUP_RETR = $04  '%0000_0011
  RF_CH = $05   '%0000_0010
  RF_SETUP = $06  '%0000_1110
  _STATUS = $07     '%0000_1110 / $E 
  OBSERVE_TX = $08  '%0000_0000
  RPD = $09   '%0000_0000 
  RX_ADDR_P0 = $0A '$E7E7E7E7E7
  RX_ADDR_P1 = $0B '$C2C2C2C2C2
  RX_ADDR_P2 = $0C  '$C3
  RX_ADDR_P3 = $0D  '$C4 
  RX_ADDR_P4 = $0E  '$C5 
  RX_ADDR_P5 = $0F  '$C6 
  TX_ADDR = $10    '$E7E7E7E7E7
  RX_PW_P0 = $11   '%0000_0000
  RX_PW_P1 = $12   '%0000_0000 
  RX_PW_P2 = $13   '%0000_0000 
  RX_PW_P3 = $14  '%0000_0000 
  RX_PW_P4 = $15  '%0000_0000 
  RX_PW_P5 = $16  '%0000_0000 
  FIFO_STATUS = $17 '%0001_0001 
  DYNPD = $1C   '%0000_0000
  FEATURE = $1D  '%0000_0000

OBJ 

  Spi : "dwd_nordicSpi110416a"

VAR

  long configPtr, statusPtr, rxAddressPtr, txAddressPtr
  
  byte SpiSck
  byte SpiMiso
  byte SpiMosi 
  byte SpiCsn    
  byte SpiCe
  
  byte payloadSize
  byte statusReset   

PUB Start(sck, miso, mosi, csn, ce, configPtr_, statusPtr_, addressPtr_) 
'' configPtr_ points to the location of start up parameters.
'' statusPtr_ points to the location of a byte used to clear the status register.
'' configPtr_ points to the location of the rx address the tx address should be five
'' bytes after this location.

  result := Spi.Start(miso, mosi, sck) - 1
            
  SpiSck := sck
  SpiMiso := miso
  SpiMosi := mosi 
  SpiCsn := csn     
  SpiCe := ce
  configPtr := configPtr_
  statusPtr := statusPtr_
  rxAddressPtr := addressPtr_
  txAddressPtr := addressPtr_ + 5
  
  outa[SpiSck]~
  outa[SpiMosi]~
  outa[SpiCsn]~~                          ' chip select not, active low
  outa[SpiCe]~
  
  dira[SpiSck]~~
  dira[SpiMosi]~~
  dira[SpiCsn]~~
  dira[SpiCe]~~

  payloadSize := byte[configPtr + 7] '_payloadSize
  statusReset := byte[statusPtr]
  
  'Configure for receive          
  Configure
  
PUB Configure | localIndex
{{
  Configure nRF24L01 registers for receive mode.
  Using data at location "configPtr" provided
  by parent object.

  This and many other methods are based on
  C code provided by Leon Heller in the
  Propeller Forum.
 
}}
  
  outa[SpiCe]~
   
   
  outa[SpiCsn]~   
  SpiWrite(W_REGISTER + EN_AA)
  SpiWrite(byte[configPtr + EN_AA])
  outa[SpiCsn]~~
   
  outa[SpiCsn]~
  SpiWrite(W_REGISTER + SETUP_RETR)
  SpiWrite(byte[configPtr + SETUP_RETR])    
  outa[SpiCsn]~~    
  
  outa[SpiCsn]~  
  SpiWrite(W_REGISTER + SETUP_AW)   
  SpiWrite(byte[configPtr + SETUP_AW])   
  outa[SpiCsn]~~    
  
  outa[SpiCsn]~
  SpiWrite(W_REGISTER + RF_SETUP) 
  SpiWrite(byte[configPtr + RF_SETUP])  
  outa[SpiCsn]~~

  outa[SpiCsn]~
  SpiWrite(W_REGISTER + RX_PW_P0) 
  SpiWrite(payloadSize)
  outa[SpiCsn]~~   
  
  outa[SpiCsn]~
  SpiWrite(W_REGISTER + RF_CH)
  SpiWrite(byte[rxAddressPtr + RF_CH])   
  outa[SpiCsn]~~     
  
  outa[SpiCsn]~
  SpiWrite(W_REGISTER + RX_ADDR_P0)
  repeat localIndex from 0 to 4
    SpiWrite(byte[rxAddressPtr + localIndex]) 
  outa[SpiCsn]~~
  
  outa[SpiCsn]~
  SpiWrite(W_REGISTER + TX_ADDR)
  repeat localIndex from 0 to 4
    SpiWrite(byte[txAddressPtr + localIndex]) 
  outa[SpiCsn]~~  

  outa[SpiCsn]~  
  SpiWrite(W_REGISTER + CONFIG)
  SpiWrite(byte[configPtr])
  outa[SpiCsn]~~
    
  'Start receiving
  outa[SpiCe]~~

PUB ReadPayload(stringToFillPtr) | localIndex
{{
  Reads payload from nRF24L01.
  Also flushes RX FIFO and resets IRQ state
}}    

  'Stop receiving
  outa[SpiCe]~
    
  'Read RX payload   
  outa[SpiCsn]~    
  SpiWrite(R_RX_PAYLOAD)   
  Spi.ShiftInStr(stringToFillPtr, payloadSize)
  outa[SpiCsn]~~
    
  'Flush RX FIFO    
  outa[SpiCsn]~
  SpiWrite(FLUSH_RX)    
  outa[SpiCsn]~~

  'Reset IRQ 
  outa[SpiCsn]~
  SpiWrite(W_REGISTER + _STATUS)
  SpiWrite(statusReset)   
  outa[SpiCsn]~~

  'Start receiving
  outa[SpiCe]~~

PRI SpiRead

  'outa[SpiMOSI]~~               ' write a NOOP as data is read
  result := Spi.ShiftIn
  'outa[SpiMOSI]~
   
PUB SpiReadPub(localCommand, localPtr, bytesToRead)

  outa[SpiCsn]~
  SpiWrite(localCommand)
  Spi.ShiftInStr(localPtr, bytesToRead) 
  outa[SpiCsn]~~
   
PUB SpiWrite(byteOut)

  Spi.ShiftOut(byteOut)
   
PUB SpiWritePub(byteOut)

  outa[SpiCsn]~ 
  SpiWrite(byteOut)
  outa[SpiCsn]~~

PUB Status

  outa[SpiCsn]~  
  result := SpiRead
  outa[SpiCsn]~~

  'Reset IRQ 
  outa[SpiCsn]~
  SpiWrite(W_REGISTER + _STATUS)
  SpiWrite(statusReset)  
  outa[SpiCsn]~~
   
PUB TransmitString(localPtr) | localIndex
'' For now this method transmit the a full payload of bytes starting with
'' the memorey location "localPtr".
'' I'd like to add the ability to transmit strings larger than the
'' payload size.  I'll need to be about to use the auto retransmit
'' ability of the new modules.  I also want to come up with a system
'' of acknowlegding packets when using older modules.

  outa[SpiCe]~
  'Take out of rx mode

  outa[SpiCsn]~
  SpiWrite(W_REGISTER + _STATUS)
  SpiWrite(statusReset)
  outa[SpiCsn]~~

  outa[SpiCsn]~
  SpiWrite(W_REGISTER + CONFIG)
  SpiWrite(byte[configPtr] - 1) ' PTX mode
  outa[SpiCsn]~~

  outa[SpiCsn]~
  SpiWrite(FLUSH_TX)
  outa[SpiCsn]~~

  outa[SpiCsn]~
  SpiWrite(W_TX_PAYLOAD)
  Spi.ShiftOutStr(localPtr, payloadSize)  
  outa[SpiCsn]~~

  outa[SpiCe]~~
  waitcnt(1000 + cnt)           ' > 10us 800 = 10 us @ 80MHz
  outa[SpiCe]~                  ' Spin might be slow enough not to need a delay

  outa[SpiCsn]~
  SpiWrite(W_REGISTER + TX_ADDR)                        ' I shouldn't need to do this.
  repeat localIndex from 0 to 4                         ' I set this in the config method
    SpiWrite(byte[txAddressPtr + localIndex]) 
  outa[SpiCsn]~~
  
  outa[SpiCsn]~ 
  SpiWrite(W_REGISTER + CONFIG)
  SpiWrite(byte[configPtr])
  outa[SpiCsn]~~
    
  'Start receiving
  outa[SpiCe]~~      